org.apache.cassandra.io.util

## Class NIODataInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.cassandra.io.util.RebufferingInputStream
    - - org.apache.cassandra.io.util.NIODataInputStream

All Implemented Interfaces:
  java.io.Closeable, java.io.DataInput, java.lang.AutoCloseable, DataInputPlus

    public class NIODataInputStream
    extends RebufferingInputStream

Rough equivalent of BufferedInputStream and DataInputStream wrapping the input stream of a File or Socket Created to work around the fact that when BIS + DIS delegate to NIO for socket IO they will allocate large thread local direct byte buffers when a large array is used to read. There may also be some performance improvement due to using a DBB as the underlying buffer for IO and the removal of some indirection and delegation when it comes to reading out individual values, but that is not the goal. Closing NIODataInputStream will invoke close on the ReadableByteChannel provided at construction. NIODataInputStream is not thread safe.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.cassandra.io.util.DataInputPlus

`DataInputPlus.DataInputStreamPlus`

### Field Summary

Fields
`protected java.nio.channels.ReadableByteChannel` `channel`

### Fields inherited from class org.apache.cassandra.io.util.RebufferingInputStream

`buffer`

### Constructor Summary

Constructors
Constructor and Description
`NIODataInputStream(java.nio.channels.ReadableByteChannel channel, int bufferSize)`

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `available()`
`void` `close()`
`protected void` `reBuffer()` Implementations must implement this method to refill the buffer.

### Methods inherited from class org.apache.cassandra.io.util.RebufferingInputStream

`read, read, readBoolean, readByte, readChar, readDouble, readFloat, readFully, readFully, readInt, readLine, readLong, readPrimitiveSlowly, readShort, readUnsignedByte, readUnsignedShort, readUnsignedVInt, readUTF, readVInt, skipBytes`

### Methods inherited from class java.io.InputStream

`mark, markSupported, read, reset, skip`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.cassandra.io.util.DataInputPlus

`skipBytesFully`

### Field Detail

#### channel

    protected final java.nio.channels.ReadableByteChannel channel

### Constructor Detail

#### NIODataInputStream

    public NIODataInputStream(java.nio.channels.ReadableByteChannel channel,
                              int bufferSize)

### Method Detail

#### reBuffer

    protected void reBuffer()
                     throws java.io.IOException

Description copied from class: `RebufferingInputStream`
Implementations must implement this method to refill the buffer. They can expect the buffer to be empty when this method is invoked.

Specified by:
  `reBuffer` in class `RebufferingInputStream`
Throws:
  `java.io.IOException`

#### close

    public void close()
               throws java.io.IOException

Specified by:
  `close` in interface `java.io.Closeable`
Specified by:
  `close` in interface `java.lang.AutoCloseable`
Overrides:
  `close` in class `java.io.InputStream`
Throws:
  `java.io.IOException`

#### available

    public int available()
                  throws java.io.IOException

Overrides:
  `available` in class `java.io.InputStream`
Throws:
  `java.io.IOException`